/* %Z%%M%	%I% %E% Copyright 1997 J. Schilling */
#ifndef lint
static	char sccsid[] =
	"%Z%%M%	%I% %E% Copyright 1997 J. Schilling";
#endif
/*
 *	CDR device implementation for
 *	SCSI-3/mmc conforming drives
 *	e.g. Yamaha CDR-400, Ricoh MP6200
 *
 *	Currently using close_track_philips() XXX FIXME
 *
 *	Copyright (c) 1997 J. Schilling
 */
/*@@C@@*/

/*#define	DEBUG*/
#include <mconfig.h>

#include <stdio.h>
#include <standard.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <sys/file.h>

#include <utypes.h>
#include <btorder.h>
#include <scgio.h>
#include <scsidefs.h>
#include <scsireg.h>

#include "cdrecord.h"
#include "scsitransp.h"

struct	scg_cmd		scmd;
struct	scsi_inquiry	inq;

extern	int	scsibus;
extern	int	target;
extern	int	lun;

extern	int	silent;
extern	int	verbose;
extern	int	lverbose;

typedef struct opc {
	u_char	opc_speed[2];
	u_char	opc_val[6];
} opc_t;

#if defined(_BIT_FIELDS_LTOH)	/* Intel byteorder */

struct disk_info {
	u_char	data_len[2];		/* Data len without this info	*/
	Ucbf	disk_status	: 2;	/* Status of the disk		*/
	Ucbf	sess_status	: 2;	/* Status of last session	*/
	Ucbf	erasable	: 1;	/* Disk is erasable		*/
	Ucbf	res2		: 3;	/* Reserved			*/
	u_char	first_track;		/* # of first track on disk	*/
	u_char	numsess;		/* # of sessions		*/
	u_char	first_track_ls;		/* First track in last sessaion	*/
	u_char	last_track_ls;		/* Last track in last sessaion	*/
	Ucbf	res7_04		: 5;	/* Reserved			*/
	Ucbf	uru		: 1;	/* This is an unrestricted disk	*/
	Ucbf	dbc_v		: 1;	/* Disk bar code valid		*/
	Ucbf	did_v		: 1;	/* Disk id valid		*/
	u_char	disk_type;		/* Disk type			*/
	u_char	res9[3];		/* Reserved			*/
	u_char	disk_id[4];		/* Disk identification		*/
	u_char	last_lead_in[4];	/* Last session lead in time	*/
	u_char	last_lead_out[4];	/* Last session lead out time	*/
	u_char	disk_barcode[8];	/* Disk bar code		*/
	u_char	res32;			/* Reserved			*/
	u_char	num_opc_entries;	/* # of OPC table entries	*/
	opc_t	opc_table[1];		/* OPC table 			*/
};

#else				/* Motorola byteorder */

struct disk_info {
	u_char	data_len[2];		/* Data len without this info	*/
	Ucbf	res2		: 3;	/* Reserved			*/
	Ucbf	erasable	: 1;	/* Disk is erasable		*/
	Ucbf	sess_status	: 2;	/* Status of last session	*/
	Ucbf	disk_status	: 2;	/* Status of the disk		*/
	u_char	first_track;		/* # of first track on disk	*/
	u_char	numsess;		/* # of sessions		*/
	u_char	first_track_ls;		/* First track in last sessaion	*/
	u_char	last_track_ls;		/* Last track in last sessaion	*/
	Ucbf	did_v		: 1;	/* Disk id valid		*/
	Ucbf	dbc_v		: 1;	/* Disk bar code valid		*/
	Ucbf	uru		: 1;	/* This is an unrestricted disk	*/
	Ucbf	res7_04		: 5;	/* Reserved			*/
	u_char	disk_type;		/* Disk type			*/
	u_char	res9[3];		/* Reserved			*/
	u_char	disk_id[4];		/* Disk identification		*/
	u_char	last_lead_in[4];	/* Last session lead in time	*/
	u_char	last_lead_out[4];	/* Last session lead out time	*/
	u_char	disk_barcode[8];	/* Disk bar code		*/
	u_char	res32;			/* Reserved			*/
	u_char	num_opc_entries;	/* # of OPC table entries	*/
	opc_t	opc_table[1];		/* OPC table 			*/
};

#endif

LOCAL	int	mmc_load		__PR((void));
LOCAL	int	mmc_unload		__PR((void));
LOCAL	cdr_t	*identify_mmc		__PR((cdr_t *, struct scsi_inquiry *));
EXPORT	long	msf_to_lba		__PR((int m, int s, int f));
LOCAL	int	get_diskinfo		__PR((struct disk_info *dip));
LOCAL	void	di_to_dstat		__PR((struct disk_info *dip, dstat_t *dsp));
LOCAL	int	getdisktype_mmc		__PR((cdr_t *dp, dstat_t *dsp));
LOCAL	int	speed_select_mmc	__PR((int speed, int dummy));
LOCAL	int	next_wr_addr_mmc	__PR((int track, track_t *trackp, long *ap));
LOCAL	int	open_track_mmc		__PR((cdr_t *dp, int track, track_t *trackp));
LOCAL	int	close_track_mmc		__PR((int track, track_t *trackp));
LOCAL	int	open_session_mmc	__PR((int toctype, int multi));
LOCAL	int	fixate_mmc		__PR((int onp, int dummy, int toctype, int tracks, track_t *trackp));
LOCAL	int	blank_mmc		__PR((long addr, int blanktype));

LOCAL int
mmc_load()
{
	return (scsi_load_unload(1));
}

LOCAL int
mmc_unload()
{
	return (scsi_load_unload(0));
}

cdr_t	cdr_mmc = {
	0,
	CDR_TAO|CDR_DAO|CDR_PACKET|CDR_SWABAUDIO,
	"mmc_cdr",
	"generic SCSI-3/mmc CD-R driver",
	identify_mmc,
	drive_attach,
	getdisktype_mmc,
	scsi_load,
/*	mmc_load,*/
	scsi_unload,
	recovery_needed,
	recover,
	speed_select_mmc,
	select_secsize,
	next_wr_addr_mmc,
	reserve_track,
	scsi_cdr_write,
	open_track_mmc,
	close_track_mmc,
	open_session_mmc,
	cmd_dummy,
	read_session_offset,
	fixate_mmc,
	blank_mmc,
};

/*
 * SCSI-3/mmc conformant CD drive
 */
cdr_t	cdr_cd = {
	0,
	CDR_ISREADER|CDR_SWABAUDIO,
	"mmc_cd",
	"generic SCSI-3/mmc CD driver",
	identify_mmc,
	drive_attach,
	drive_getdisktype,
	scsi_load,
	scsi_unload,
	cmd_dummy, 				/* recovery_needed	*/
	(int(*)__PR((int)))cmd_dummy,		/* recover		*/
	speed_select_mmc,
	select_secsize,
	(int(*)__PR((int, track_t *, long *)))cmd_dummy,	/* next_wr_addr		*/
	reserve_track,
	scsi_cdr_write,
	open_track_mmc,
	close_track_mmc,
	(int(*)__PR((int, int)))cmd_dummy,
	cmd_dummy,
	read_session_offset,
	fixation,
	blank_dummy,
};

/*
 * Old pre SCSI-3/mmc CD drive
 */
cdr_t	cdr_oldcd = {
	0,
	CDR_ISREADER,
	"scsi2_cd",
	"generic SCSI-2 CD driver",
	identify_mmc,
	drive_attach,
	drive_getdisktype,
	scsi_load,
	scsi_unload,
	cmd_dummy, 				/* recovery_needed	*/
	(int(*)__PR((int)))cmd_dummy,		/* recover		*/
	speed_select_mmc,
	select_secsize,
	(int(*)__PR((int, track_t *, long *)))cmd_dummy,	/* next_wr_addr		*/
	reserve_track,
	scsi_cdr_write,
	open_track_mmc,
	close_track_mmc,
	(int(*)__PR((int, int)))cmd_dummy,
	cmd_dummy,
	read_session_offset_philips,
	fixation,
	blank_dummy,
};

struct cd__mode_data {
	struct scsi_mode_header	header;
	union cd_pagex	{
		struct cd_mode_page_05	page05;
		struct cd_mode_page_2A	page2A;
	} pagex;
};

LOCAL cdr_t *
identify_mmc(dp, ip)
	cdr_t			*dp;
	struct scsi_inquiry	*ip;
{
	BOOL	cdrr	 = FALSE;	/* Read CD-R	*/
	BOOL	cdwr	 = FALSE;	/* Write CD-R	*/
	BOOL	cdrrw	 = FALSE;	/* Read CD-RW	*/
	BOOL	cdwrw	 = FALSE;	/* Write CD-RW	*/
	char	modes[256];

	if (ip->type != INQ_WORM && ip->type != INQ_ROMD)
		return ((cdr_t *)0);

	allow_atapi(TRUE);	/* Try to switch to 10 byte mode cmds */

	if (!mmc_check(&cdrr, &cdwr, &cdrrw, &cdwrw))
		return (&cdr_oldcd);	/* Pre SCSI-3/mmc drive	 	*/

	if (!cdwr)			/* SCSI-3/mmc CD drive		*/
		return (&cdr_cd);
	return (dp);			/* Generic SCSI-3/mmc CD-R	*/
}

EXPORT long
msf_to_lba(m, s, f)
	int	m;
	int	s;
	int	f;
{
	long	ret = m * 60 + s;

	ret *= 75;
	ret += f;
	if (m < 90)
		ret += 150;
	else
		ret -= 450150;
	return (ret);
}

LOCAL int
get_diskinfo(dip)
	struct disk_info *dip;
{
	int	len;
	int	ret;

	fillbytes((caddr_t)dip, sizeof(*dip), '\0');

	if (read_disk_info((caddr_t)dip, 2) < 0)
		return (-1);
	len = a_to_u_short(dip->data_len);
	ret = read_disk_info((caddr_t)dip, len);

#ifdef	DEBUG
	scsiprbytes("Disk info:", (u_char *)dip,
				len-scsigetresid());
#endif
	return (ret);
}

LOCAL void
di_to_dstat(dip, dsp)
	struct disk_info	*dip;
	dstat_t	*dsp;
{
	dsp->ds_diskid = a_to_u_long(dip->disk_id);
	if (dip->did_v)
		dsp->ds_flags |= DSF_DID_V;
	dsp->ds_diskstat = dip->disk_status;
	dsp->ds_sessstat = dip->sess_status;

	dsp->ds_maxblock = msf_to_lba(dip->last_lead_out[1],
					dip->last_lead_out[2],
					dip->last_lead_out[3]);
}

LOCAL int
getdisktype_mmc(dp, dsp)
	cdr_t	*dp;
	dstat_t	*dsp;
{
extern	char	*buf;
	struct disk_info *dip;

	dip = (struct disk_info *)buf;
	if (get_diskinfo(dip) < 0)
		return (-1);

	/*
	 * Check for non writable disk first.
	 */
	if (dip->disk_status == DS_COMPLETE) {
		errmsgno(EX_BAD, "Drive needs to reload the media to return to proper status.\n");

		unload_media(dp, F_EJECT);
		load_media(dp);
	}
	if (get_diskinfo(dip) < 0)
		return (-1);
	di_to_dstat(dip, dsp);

	return (drive_getdisktype(dp, dsp));
}

LOCAL int
speed_select_mmc(speed, dummy)
	int	speed;
	int	dummy;
{
	u_char	mode[0x100];
	int	len;
	struct	cd_mode_page_05 *mp;

	fillbytes((caddr_t)mode, sizeof(mode), '\0');

	if (!get_mode_params(0x05, "CD write parameter",
			mode, (u_char *)0, (u_char *)0, (u_char *)0, &len))
		return (-1);
	if (len == 0)
		return (-1);

	mp = (struct cd_mode_page_05 *)
		(mode + sizeof(struct scsi_mode_header) +
		((struct scsi_mode_header *)mode)->blockdesc_len);
#ifdef	DEBUG
	scsiprbytes("CD write parameter:", (u_char *)mode, len);
#endif


	mp->test_write = dummy != 0;
	/*
	 * Set default values:
	 * Write type = 01 (track at once)
	 * Track mode = 04 (CD-ROM)
	 * Data block type = 08 (CD-ROM)
	 * Session type = 00 (CD-ROM)
	 */
	mp->write_type = WT_TAO;
	mp->track_mode = TM_DATA; 
	mp->dbtype = DB_ROM_MODE1;
	mp->session_format = SES_DA_ROM;/* Matsushita has illegal def. value */


#ifdef	DEBUG
	scsiprbytes("CD write parameter:", (u_char *)mode, len);
#endif
	if (!set_mode_params("CD write parameter", mode, len, 0, -1))
		return (-1);

/*XXX max speed aus page 0x2A lesen !! */

/*	if (scsi_set_speed(-1, speed*176) < 0)*/

	/*
	 * 44100 * 2 * 2 =  176400 bytes/s
	 *
	 * The right formula would be:
	 * tmp = (((long)speed) * 1764) / 10;
	 *
	 * But the standard is rounding the wrong way.
	 * Furtunately rounding down is guaranteed.
	 */
	if (scsi_set_speed(-1, speed*177) < 0)
		return (-1);
	return (0);
}

#if defined(_BIT_FIELDS_LTOH)	/* Intel byteorder */

struct track_info {
	u_char	data_len[2];		/* Data len without this info	*/
	u_char	track_number;		/* Track number for this info	*/
	u_char	session_number;		/* Session number for this info	*/
	u_char	res4;			/* Reserved			*/
	Ucbf	track_mode	: 4;	/* Track mode (Q-sub control)	*/
	Ucbf	copy		: 1;	/* This track is a higher copy	*/
	Ucbf	damage		: 1;	/* if 1 & nwa_valid 0: inc track*/
	Ucbf	res5_67		: 2;	/* Reserved			*/
	Ucbf	data_mode	: 4;	/* Data mode of this track	*/
	Ucbf	fp		: 1;	/* This is a fixed packet track	*/
	Ucbf	packet		: 1;	/* This track is in packet mode	*/
	Ucbf	blank		: 1;	/* This is an invisible track	*/
	Ucbf	rt		: 1;	/* This is a reserved track	*/
	Ucbf	nwa_valid	: 1;	/* Next writable addr valid	*/
	Ucbf	res7_17		: 7;	/* Reserved			*/
	u_char	track_start[4];		/* Track start address		*/
	u_char	next_writable_addr[4];	/* Next writable address	*/
	u_char	free_blocks[4];		/* Free usr blocks in this track*/
	u_char	packet_size[4];		/* Packet size if in fixed mode	*/
	u_char	track_size[4];		/* # of user data blocks in trk	*/
};

#else				/* Motorola byteorder */

struct track_info {
	u_char	data_len[2];		/* Data len without this info	*/
	u_char	track_number;		/* Track number for this info	*/
	u_char	session_number;		/* Session number for this info	*/
	u_char	res4;			/* Reserved			*/
	Ucbf	res5_67		: 2;	/* Reserved			*/
	Ucbf	damage		: 1;	/* if 1 & nwa_valid 0: inc track*/
	Ucbf	copy		: 1;	/* This track is a higher copy	*/
	Ucbf	track_mode	: 4;	/* Track mode (Q-sub control)	*/
	Ucbf	rt		: 1;	/* This is a reserved track	*/
	Ucbf	blank		: 1;	/* This is an invisible track	*/
	Ucbf	packet		: 1;	/* This track is in packet mode	*/
	Ucbf	fp		: 1;	/* This is a fixed packet track	*/
	Ucbf	data_mode	: 4;	/* Data mode of this track	*/
	Ucbf	res7_17		: 7;	/* Reserved			*/
	Ucbf	nwa_valid	: 1;	/* Next writable addr valid	*/
	u_char	track_start[4];		/* Track start address		*/
	u_char	next_writable_addr[4];	/* Next writable address	*/
	u_char	free_blocks[4];		/* Free usr blocks in this track*/
	u_char	packet_size[4];		/* Packet size if in fixed mode	*/
	u_char	track_size[4];		/* # of user data blocks in trk	*/
};

#endif

LOCAL int
next_wr_addr_mmc(track, trackp, ap)
	int	track;
	track_t	*trackp;
	long	*ap;
{
	struct	track_info	track_info;
	long	next_addr;
	int	result = -1;


	/*
	 * Reading info for current track may require doing the read_track_info
	 * with either the track number (if the track is currently being written)
	 * or with 0xFF (if the track hasn't been started yet and is invisible
	 */

	if (track > 0 && is_packet(trackp)) {
		silent ++;
		result = read_track_info((caddr_t)&track_info, track,
							sizeof(track_info));
		silent --;
	}

	if (result < 0) {
		if (read_track_info((caddr_t)&track_info, 0xFF,
						sizeof(track_info)) < 0)
		return (-1);
	}
	if (verbose)
		scsiprbytes("track info:", (u_char *)&track_info,
				sizeof(track_info)-scsigetresid());
	next_addr = a_to_u_long(track_info.next_writable_addr);
	if (ap)
		*ap = next_addr;
	return (0);
}

int	st2mode[] = {
	0,		/* 0			*/
	TM_DATA,	/* 1 ST_ROM_MODE1	*/
	TM_DATA,	/* 2 ST_ROM_MODE2	*/
	0,		/* 3			*/
	0,		/* 4 ST_AUDIO_NOPRE	*/
	TM_PREEM,	/* 5 ST_AUDIO_PRE	*/
	0,		/* 6			*/
	0,		/* 7			*/
};

LOCAL int
open_track_mmc(dp, track, trackp)
	cdr_t	*dp;
	int	track;
	track_t *trackp;
{
	u_char	mode[0x100];
	int	len;
	struct	cd_mode_page_05 *mp;

	fillbytes((caddr_t)mode, sizeof(mode), '\0');

	if (!get_mode_params(0x05, "CD write parameter",
			mode, (u_char *)0, (u_char *)0, (u_char *)0, &len))
		return (-1);
	if (len == 0)
		return (-1);

	mp = (struct cd_mode_page_05 *)
		(mode + sizeof(struct scsi_mode_header) +
		((struct scsi_mode_header *)mode)->blockdesc_len);


/*	mp->track_mode = ???;*/
	mp->track_mode = st2mode[trackp->sectype & ST_MASK];
/*	mp->copy = ???;*/
	mp->dbtype = trackp->dbtype;

/*i_to_short(mp->audio_pause_len, 300);*/
/*i_to_short(mp->audio_pause_len, 150);*/
/*i_to_short(mp->audio_pause_len, 0);*/

	if (is_packet(trackp)) {
		mp->write_type = WT_PACKET;
		mp->track_mode |= TM_INCREMENTAL;
		mp->fp = (trackp->pktsize > 0) ? 1 : 0;
		i_to_4_byte(mp->packet_size, trackp->pktsize);
	} else {
		mp->write_type = WT_TAO;
		mp->fp = 0;
		i_to_4_byte(mp->packet_size, 0);
	}
 
#ifdef	DEBUG
	scsiprbytes("CD write parameter:", (u_char *)mode, len);
#endif
	if (!set_mode_params("CD write parameter", mode, len, 0, trackp->secsize))
		return (-1);

	return (0);
}

LOCAL int
close_track_mmc(track, trackp)
	int	track;
	track_t	*trackp;
{
	if (scsi_flush_cache() < 0) {
		printf("Trouble flushing the cache\n");
		return -1;
	}
	if (is_packet(trackp) && !is_noclose(trackp)) {
			/* close the incomplete track */
		return (scsi_close_tr_session(1, 0xFF));
	}
	return (0);
}

int	toc2sess[] = {
	SES_DA_ROM,	/* CD-DA		 */
	SES_DA_ROM,	/* CD-ROM		 */
	SES_XA,		/* CD-ROM XA mode 1	 */
	SES_XA,		/* CD-ROM XA MODE 2	 */
	SES_CDI,	/* CDI			 */
	SES_DA_ROM,	/* Invalid - use default */
	SES_DA_ROM,	/* Invalid - use default */
};

LOCAL int
open_session_mmc(toctype, multi)
	int	toctype;
	int	multi;
{
	u_char	mode[0x100];
	int	len;
	struct	cd_mode_page_05 *mp;

	fillbytes((caddr_t)mode, sizeof(mode), '\0');

	if (!get_mode_params(0x05, "CD write parameter",
			mode, (u_char *)0, (u_char *)0, (u_char *)0, &len))
		return (-1);
	if (len == 0)
		return (-1);

	mp = (struct cd_mode_page_05 *)
		(mode + sizeof(struct scsi_mode_header) +
		((struct scsi_mode_header *)mode)->blockdesc_len);

	mp->write_type = WT_TAO; /* fix to allow DAO later */

	mp->multi_session = (multi != 0) ? MS_MULTI : MS_NONE;
	mp->session_format = toc2sess[toctype & TOC_MASK];

#ifdef	DEBUG
	scsiprbytes("CD write parameter:", (u_char *)mode, len);
#endif
	if (!set_mode_params("CD write parameter", mode, len, 0, -1))
		return (-1);

	return (0);
}

LOCAL int
fixate_mmc(onp, dummy, toctype, tracks, trackp)
	int	onp;
	int	dummy;
	int	toctype;
	int	tracks;
	track_t	*trackp;
{
	return (scsi_close_tr_session(2, 0));
}

char	*blank_types[] = {
	"entire disk",
	"PMA, TOC, pregap",
	"incomplete track",
	"reserved track",
	"tail of track",
	"closing of last session",
	"last session",
	"reserved blanking type",
};

LOCAL int
blank_mmc(addr, blanktype)
	long	addr;
	int	blanktype;
{
	BOOL	cdrr	 = FALSE;	/* Read CD-R	*/
	BOOL	cdwr	 = FALSE;	/* Write CD-R	*/
	BOOL	cdrrw	 = FALSE;	/* Read CD-RW	*/
	BOOL	cdwrw	 = FALSE;	/* Write CD-RW	*/

	mmc_check(&cdrr, &cdwr, &cdrrw, &cdwrw);
	if (!cdwrw)
		return (blank_dummy(addr, blanktype));

	if (lverbose)
		printf("Blanking %s\n", blank_types[blanktype & 0x07]);

	return (scsi_blank(addr, blanktype));
}
